/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.orkut.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for CommunityMembershipStatus.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CommunityMembershipStatus extends GenericJson {

  /**
   * Whether the user can create a poll in this community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean canCreatePoll;

  /**
   * Whether the user can create a topic in this community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean canCreateTopic;

  /**
   * Whether the user can perform a shout operation in this community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean canShout;

  /**
   * Whether the session user is a community co-owner.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isCoOwner;

  /**
   * Whether the user is following this community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isFollowing;

  /**
   * Whether the session user is a community moderator.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isModerator;

  /**
   * Whether the session user is the community owner.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isOwner;

  /**
   * Whether the restore operation is available for the community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isRestoreAvailable;

  /**
   * Whether the take-back operation is available for the community.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isTakebackAvailable;

  /**
   * Kind of this item. Always orkut#communityMembershipStatus.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The status of the current link between the community and the user.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String status;

  /**
   * Whether the user can create a poll in this community.
   * The value returned may be {@code null}.
   */
  public Boolean getCanCreatePoll() {
    return canCreatePoll;
  }

  /**
   * Whether the user can create a poll in this community.
   * The value set may be {@code null}.
   */
  public CommunityMembershipStatus setCanCreatePoll(Boolean canCreatePoll) {
    this.canCreatePoll = canCreatePoll;
    return this;
  }

  /**
   * Whether the user can create a topic in this community.
   * The value returned may be {@code null}.
   */
  public Boolean getCanCreateTopic() {
    return canCreateTopic;
  }

  /**
   * Whether the user can create a topic in this community.
   * The value set may be {@code null}.
   */
  public CommunityMembershipStatus setCanCreateTopic(Boolean canCreateTopic) {
    this.canCreateTopic = canCreateTopic;
    return this;
  }

  /**
   * Whether the user can perform a shout operation in this community.
   * The value returned may be {@code null}.
   */
  public Boolean getCanShout() {
    return canShout;
  }

  /**
   * Whether the user can perform a shout operation in this community.
   * The value set may be {@code null}.
   */
  public CommunityMembershipStatus setCanShout(Boolean canShout) {
    this.canShout = canShout;
    return this;
  }

  /**
   * Whether the session user is a community co-owner.
   * The value returned may be {@code null}.
   */
  public Boolean getIsCoOwner() {
    return isCoOwner;
  }

  /**
   * Whether the session user is a community co-owner.
   * The value set may be {@code null}.
   */
  public CommunityMembershipStatus setIsCoOwner(Boolean isCoOwner) {
    this.isCoOwner = isCoOwner;
    return this;
  }

  /**
   * Whether the user is following this community.
   * The value returned may be {@code null}.
   */
  public Boolean getIsFollowing() {
    return isFollowing;
  }

  /**
   * Whether the user is following this community.
   * The value set may be {@code null}.
   */
  public CommunityMembershipStatus setIsFollowing(Boolean isFollowing) {
    this.isFollowing = isFollowing;
    return this;
  }

  /**
   * Whether the session user is a community moderator.
   * The value returned may be {@code null}.
   */
  public Boolean getIsModerator() {
    return isModerator;
  }

  /**
   * Whether the session user is a community moderator.
   * The value set may be {@code null}.
   */
  public CommunityMembershipStatus setIsModerator(Boolean isModerator) {
    this.isModerator = isModerator;
    return this;
  }

  /**
   * Whether the session user is the community owner.
   * The value returned may be {@code null}.
   */
  public Boolean getIsOwner() {
    return isOwner;
  }

  /**
   * Whether the session user is the community owner.
   * The value set may be {@code null}.
   */
  public CommunityMembershipStatus setIsOwner(Boolean isOwner) {
    this.isOwner = isOwner;
    return this;
  }

  /**
   * Whether the restore operation is available for the community.
   * The value returned may be {@code null}.
   */
  public Boolean getIsRestoreAvailable() {
    return isRestoreAvailable;
  }

  /**
   * Whether the restore operation is available for the community.
   * The value set may be {@code null}.
   */
  public CommunityMembershipStatus setIsRestoreAvailable(Boolean isRestoreAvailable) {
    this.isRestoreAvailable = isRestoreAvailable;
    return this;
  }

  /**
   * Whether the take-back operation is available for the community.
   * The value returned may be {@code null}.
   */
  public Boolean getIsTakebackAvailable() {
    return isTakebackAvailable;
  }

  /**
   * Whether the take-back operation is available for the community.
   * The value set may be {@code null}.
   */
  public CommunityMembershipStatus setIsTakebackAvailable(Boolean isTakebackAvailable) {
    this.isTakebackAvailable = isTakebackAvailable;
    return this;
  }

  /**
   * Kind of this item. Always orkut#communityMembershipStatus.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Kind of this item. Always orkut#communityMembershipStatus.
   * The value set may be {@code null}.
   */
  public CommunityMembershipStatus setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The status of the current link between the community and the user.
   * The value returned may be {@code null}.
   */
  public String getStatus() {
    return status;
  }

  /**
   * The status of the current link between the community and the user.
   * The value set may be {@code null}.
   */
  public CommunityMembershipStatus setStatus(String status) {
    this.status = status;
    return this;
  }

}
