/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.orkut.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for OrkutActivitypersonResource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class OrkutActivitypersonResource extends GenericJson {

  /**
   * The person's date of birth, represented as YYYY-MM-DD.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String birthday;

  /**
   * The person's gender. Values include "male", "female", and "other".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String gender;

  /**
   * The person's opensocial ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * The person's profile photo. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Image image;

  /**
   * An object that encapsulates the individual components of a person's name.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Name name;

  /**
   * The person's profile url. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String url;

  /**
   * The person's date of birth, represented as YYYY-MM-DD.
   * The value returned may be {@code null}.
   */
  public String getBirthday() {
    return birthday;
  }

  /**
   * The person's date of birth, represented as YYYY-MM-DD.
   * The value set may be {@code null}.
   */
  public OrkutActivitypersonResource setBirthday(String birthday) {
    this.birthday = birthday;
    return this;
  }

  /**
   * The person's gender. Values include "male", "female", and "other".
   * The value returned may be {@code null}.
   */
  public String getGender() {
    return gender;
  }

  /**
   * The person's gender. Values include "male", "female", and "other".
   * The value set may be {@code null}.
   */
  public OrkutActivitypersonResource setGender(String gender) {
    this.gender = gender;
    return this;
  }

  /**
   * The person's opensocial ID.
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * The person's opensocial ID.
   * The value set may be {@code null}.
   */
  public OrkutActivitypersonResource setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * The person's profile photo. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   * The value returned may be {@code null}.
   */
  public Image getImage() {
    return image;
  }

  /**
   * The person's profile photo. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   * The value set may be {@code null}.
   */
  public OrkutActivitypersonResource setImage(Image image) {
    this.image = image;
    return this;
  }

  /**
   * An object that encapsulates the individual components of a person's name.
   * The value returned may be {@code null}.
   */
  public Name getName() {
    return name;
  }

  /**
   * An object that encapsulates the individual components of a person's name.
   * The value set may be {@code null}.
   */
  public OrkutActivitypersonResource setName(Name name) {
    this.name = name;
    return this;
  }

  /**
   * The person's profile url. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   * The value returned may be {@code null}.
   */
  public String getUrl() {
    return url;
  }

  /**
   * The person's profile url. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   * The value set may be {@code null}.
   */
  public OrkutActivitypersonResource setUrl(String url) {
    this.url = url;
    return this;
  }

  /**
   * The person's profile photo. This is adapted from Google+ and was originaly introduced as extra
   * OpenSocial convenience fields.
   */
  public static final class Image extends GenericJson {

    /**
     * The URL of the person's profile photo.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String url;

    /**
     * The URL of the person's profile photo.
     * The value returned may be {@code null}.
     */
    public String getUrl() {
      return url;
    }

    /**
     * The URL of the person's profile photo.
     * The value set may be {@code null}.
     */
    public Image setUrl(String url) {
      this.url = url;
      return this;
    }

  }

  /**
   * An object that encapsulates the individual components of a person's name.
   */
  public static final class Name extends GenericJson {

    /**
     * The family name (last name) of this person.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String familyName;

    /**
     * The given name (first name) of this person.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String givenName;

    /**
     * The family name (last name) of this person.
     * The value returned may be {@code null}.
     */
    public String getFamilyName() {
      return familyName;
    }

    /**
     * The family name (last name) of this person.
     * The value set may be {@code null}.
     */
    public Name setFamilyName(String familyName) {
      this.familyName = familyName;
      return this;
    }

    /**
     * The given name (first name) of this person.
     * The value returned may be {@code null}.
     */
    public String getGivenName() {
      return givenName;
    }

    /**
     * The given name (first name) of this person.
     * The value set may be {@code null}.
     */
    public Name setGivenName(String givenName) {
      this.givenName = givenName;
      return this;
    }

  }

}
