/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.orkut.model;

import com.google.api.client.json.GenericJson;

/**
 * Links to resources related to the parent object.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class OrkutLinkResource extends GenericJson {

  /**
   * URL of the link.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String href;

  /**
   * Relation between the resource and the parent object.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String rel;

  /**
   * Title of the link.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String title;

  /**
   * Media type of the link.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String type;

  /**
   * URL of the link.
   * The value returned may be {@code null}.
   */
  public String getHref() {
    return href;
  }

  /**
   * URL of the link.
   * The value set may be {@code null}.
   */
  public OrkutLinkResource setHref(String href) {
    this.href = href;
    return this;
  }

  /**
   * Relation between the resource and the parent object.
   * The value returned may be {@code null}.
   */
  public String getRel() {
    return rel;
  }

  /**
   * Relation between the resource and the parent object.
   * The value set may be {@code null}.
   */
  public OrkutLinkResource setRel(String rel) {
    this.rel = rel;
    return this;
  }

  /**
   * Title of the link.
   * The value returned may be {@code null}.
   */
  public String getTitle() {
    return title;
  }

  /**
   * Title of the link.
   * The value set may be {@code null}.
   */
  public OrkutLinkResource setTitle(String title) {
    this.title = title;
    return this;
  }

  /**
   * Media type of the link.
   * The value returned may be {@code null}.
   */
  public String getType() {
    return type;
  }

  /**
   * Media type of the link.
   * The value set may be {@code null}.
   */
  public OrkutLinkResource setType(String type) {
    this.type = type;
    return this;
  }

}
