/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.orkut.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for Visibility.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Visibility extends GenericJson {

  /**
   * Identifies this resource as a visibility item. Value: "orkut#visibility"
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * List of resources for the visibility item.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<OrkutLinkResource> links;

  static {
    // hack to force ProGuard to consider OrkutLinkResource used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(OrkutLinkResource.class);
  }

  /**
   * The visibility of the resource. Possible values are: - default: not hidden by the user  -
   * hidden: hidden
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String visibility;

  /**
   * Identifies this resource as a visibility item. Value: "orkut#visibility"
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Identifies this resource as a visibility item. Value: "orkut#visibility"
   * The value set may be {@code null}.
   */
  public Visibility setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * List of resources for the visibility item.
   * The value returned may be {@code null}.
   */
  public java.util.List<OrkutLinkResource> getLinks() {
    return links;
  }

  /**
   * List of resources for the visibility item.
   * The value set may be {@code null}.
   */
  public Visibility setLinks(java.util.List<OrkutLinkResource> links) {
    this.links = links;
    return this;
  }

  /**
   * The visibility of the resource. Possible values are: - default: not hidden by the user  -
   * hidden: hidden
   * The value returned may be {@code null}.
   */
  public String getVisibility() {
    return visibility;
  }

  /**
   * The visibility of the resource. Possible values are: - default: not hidden by the user  -
   * hidden: hidden
   * The value set may be {@code null}.
   */
  public Visibility setVisibility(String visibility) {
    this.visibility = visibility;
    return this;
  }

}
